org.eclipse.incquery.patternlanguage.typing

## Class ITypeSystem.NullTypeSystem

- java.lang.Object
- - org.eclipse.incquery.patternlanguage.typing.ITypeSystem.NullTypeSystem

- All Implemented Interfaces:
    ITypeSystem
  Enclosing interface:
    ITypeSystem

      public static final class ITypeSystem.NullTypeSystem
      extends java.lang.Object
      implements ITypeSystem

  An empty implementation of `ITypeSystem` that can be used by the abstract pattern language module.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.eclipse.incquery.patternlanguage.typing.ITypeSystem

      `ITypeSystem.NullTypeSystem`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NullTypeSystem()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IInputKey` | `extractColumnDescriptor(RelationType type, int columnIndex)` Extracts the model-specific column type of the given index from a RelationType declaration
    `IInputKey` | `extractTypeDescriptor(Type type)` Extracts the model-specific types from a Type declaration.
    `boolean` | `isConformant(IInputKey expectedType, IInputKey actualType)` Decides whether the second type is compatible with the first one
    `boolean` | `isConformToRelationColumn(IInputKey relationType, int columnIndex, IInputKey columnType)` Decides whether the reference can have a selected type at its given column.
    `org.eclipse.xtext.common.types.JvmTypeReference` | `toJvmTypeReference(IInputKey type, org.eclipse.emf.ecore.EObject context)` Creates a type reference for model inference from a selected type.
    `java.lang.String` | `typeString(IInputKey type)` Converts a type object to a user-visible description string.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### NullTypeSystem

          public NullTypeSystem()

  - ### Method Detail

    - #### isConformant

          public boolean isConformant(IInputKey expectedType,
                                      IInputKey actualType)

      Description copied from interface: `ITypeSystem`
      Decides whether the second type is compatible with the first one
      Specified by:
        `isConformant` in interface `ITypeSystem`

    - #### isConformToRelationColumn

          public boolean isConformToRelationColumn(IInputKey relationType,
                                                   int columnIndex,
                                                   IInputKey columnType)

      Description copied from interface: `ITypeSystem`
      Decides whether the reference can have a selected type at its given column.
      Specified by:
        `isConformToRelationColumn` in interface `ITypeSystem`

    - #### extractTypeDescriptor

          public IInputKey extractTypeDescriptor(Type type)

      Description copied from interface: `ITypeSystem`
      Extracts the model-specific types from a Type declaration.
      Specified by:
        `extractTypeDescriptor` in interface `ITypeSystem`
      Parameters:
        `type` - either the `Type` or the `RelationType` instance
      Returns:
        model-specific type representation

    - #### extractColumnDescriptor

          public IInputKey extractColumnDescriptor(RelationType type,
                                                   int columnIndex)

      Description copied from interface: `ITypeSystem`
      Extracts the model-specific column type of the given index from a RelationType declaration
      Specified by:
        `extractColumnDescriptor` in interface `ITypeSystem`

    - #### toJvmTypeReference

          public org.eclipse.xtext.common.types.JvmTypeReference toJvmTypeReference(IInputKey type,
                                                                                    org.eclipse.emf.ecore.EObject context)

      Description copied from interface: `ITypeSystem`
      Creates a type reference for model inference from a selected type.
      Specified by:
        `toJvmTypeReference` in interface `ITypeSystem`

    - #### typeString

          public java.lang.String typeString(IInputKey type)

      Description copied from interface: `ITypeSystem`
      Converts a type object to a user-visible description string.
      Specified by:
        `typeString` in interface `ITypeSystem`
      Parameters:
        `type` - either a `Type`, or a model-specific type instance
      Returns:
        the string representation of the selected type